should = require "should"

describe "load", ->
  configloader = require '../omg-configloader.coffee'

  it "should load", ->
    config = configloader.zmq
    {standardAddress, standardTransport, reqrepbroker, pushpullbroker, pubsubbroker} = config
    config.should.not.be.empty()

  describe "zmq config", ->
    config = configloader.zmq
    {standardAddress, standardTransport, reqrepbroker, pushpullbroker, pubsubbroker} = config

    it "should have config for standardAddress", ->
      standardAddress.should.be.equal "0.0.0.0"

    it "should have config for standardTransport", ->
      standardTransport.should.be.equal "tcp"

    it "should have config for reqrepbroker", ->
      reqrepbroker.should.be.have.properties ["rep", "req"]
      reqrepbroker.req.should.be.a.Number()
      reqrepbroker.rep.should.be.a.Number()

    it "should have config for pushpullbroker", ->
      pushpullbroker.should.be.have.properties ["pull", "push"]
      pushpullbroker.push.should.be.a.Number()
      pushpullbroker.pull.should.be.a.Number()

    it "should have config for pubsubbroker", ->
      console.log pubsubbroker
      pubsubbroker.should.be.have.properties ["sub", "pub"]
      pubsubbroker.pub.should.be.a.Number()
      pubsubbroker.sub.should.be.a.Number()

  describe "producer config", ->
    config = configloader.producers
    {standardTransport, standardAddress, push, pull, pubSub, reqRep} = config
    it "should return ports for producer sockets", ->
      push.should.be.equal 9007
      pull.should.be.equal 9008
      pubSub.should.be.equal 9009
      reqRep.should.be.equal 9010
    it "should return transport and address where producers can connect", ->
      standardTransport.should.be.equal "tcp"
      standardAddress.should.be.equal "127.0.0.1"

  describe "server config", ->
    config = configloader.server
    {port, https, logLevel, frontendDir} = config
    it "should return transport, port and frontend directory for webserver", ->

      port.should.be.equal 80
      https.should.be.equal false
      frontendDir.should.be.equal "webApp/bin"
